from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File

Blastpgp_V0_1_0 = CommandToolBuilder(tool="blastpgp", base_command=["blastpgp"], inputs=[ToolInput(tag="in_database_default_", input_type=Boolean(optional=True), prefix="-d", doc=InputDocumentation(doc="Database [String]\ndefault = nr")), ToolInput(tag="in_query_file_needed", input_type=Boolean(optional=True), prefix="-i", doc=InputDocumentation(doc="Query File (not needed if restarting from scoremat) [File In]  Optional\ndefault = stdin")), ToolInput(tag="in_multiple_hits_window", input_type=Boolean(optional=True), prefix="-A", doc=InputDocumentation(doc="Multiple Hits window size [Integer]\ndefault = 40")), ToolInput(tag="in_threshold_extending_hits", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="Threshold for extending hits [Integer]\ndefault = 11")), ToolInput(tag="in_expectation_value_e", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="Expectation value (E) [Real]\ndefault = 10.0")), ToolInput(tag="in_alignment_view_options", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc="alignment view options:")), ToolInput(tag="in_output_file_stdout", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="Output File for Alignment [File Out]  Optional\ndefault = stdout")), ToolInput(tag="in_dropoff_x_default", input_type=Boolean(optional=True), prefix="-y", doc=InputDocumentation(doc="Dropoff (X) for blast extensions in bits (default if zero) [Real]\ndefault = 7.0")), ToolInput(tag="in_multiple_hit_single", input_type=Boolean(optional=True), prefix="-P", doc=InputDocumentation(doc="0 for multiple hit, 1 for single hit [Integer]\ndefault = 0")), ToolInput(tag="in_filter_query_sequence", input_type=Boolean(optional=True), prefix="-F", doc=InputDocumentation(doc="Filter query sequence with SEG [String]\ndefault = F")), ToolInput(tag="in_cost_open_default", input_type=Boolean(optional=True), prefix="-G", doc=InputDocumentation(doc="Cost to open a gap [Integer]\ndefault = 11")), ToolInput(tag="in_cost_extend_default", input_type=Boolean(optional=True), prefix="-E", doc=InputDocumentation(doc="Cost to extend a gap [Integer]\ndefault = 1")), ToolInput(tag="in_x_dropoff_value_gapped", input_type=Boolean(optional=True), prefix="-X", doc=InputDocumentation(doc="X dropoff value for gapped alignment (in bits) [Integer]\ndefault = 15")), ToolInput(tag="in_number_bits_trigger", input_type=Boolean(optional=True), prefix="-N", doc=InputDocumentation(doc="Number of bits to trigger gapping [Real]\ndefault = 22.0")), ToolInput(tag="in_start_required_region", input_type=Boolean(optional=True), prefix="-S", doc=InputDocumentation(doc="Start of required region in query [Integer]\ndefault = 1")), ToolInput(tag="in_end_required_region", input_type=Boolean(optional=True), prefix="-H", doc=InputDocumentation(doc="End of required region in query (-1 indicates end of query) [Integer]\ndefault = -1")), ToolInput(tag="in_number_use_default", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="Number of processors to use [Integer]\ndefault = 1")), ToolInput(tag="in_show_gis_deflines", input_type=Boolean(optional=True), prefix="-I", doc=InputDocumentation(doc="Show GI's in deflines [T/F]\ndefault = F")), ToolInput(tag="in_constant_uses_method", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="Constant in pseudocounts for multipass version; 0 uses entropy method; otherwise a value near 30 is recommended [Integer]\ndefault = 0")), ToolInput(tag="in_maximum_number_passes", input_type=Boolean(optional=True), prefix="-j", doc=InputDocumentation(doc="Maximum number of passes to use in  multipass version [Integer]\ndefault = 1")), ToolInput(tag="in_believe_defline_default", input_type=Boolean(optional=True), prefix="-J", doc=InputDocumentation(doc="Believe the query defline [T/F]\ndefault = F")), ToolInput(tag="in_x_dropoff_value_final", input_type=Boolean(optional=True), prefix="-Z", doc=InputDocumentation(doc="X dropoff value for final gapped alignment (in bits) [Integer]\ndefault = 25")), ToolInput(tag="in_seqalign_file_be", input_type=File(optional=True), prefix="-O", doc=InputDocumentation(doc="SeqAlign file ('Believe the query defline' must be TRUE) [File Out]  Optional")), ToolInput(tag="in_matrix_default_blosum", input_type=Boolean(optional=True), prefix="-M", doc=InputDocumentation(doc="Matrix [String]\ndefault = BLOSUM62")), ToolInput(tag="in_number_database_sequences", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="Number of database sequences to show one-line descriptions for (V) [Integer]\ndefault = 500")), ToolInput(tag="in_number_database_sequence", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="Number of database sequence to show alignments for (B) [Integer]\ndefault = 250")), ToolInput(tag="in_output_file_psiblast_checkpointing_optional", input_type=File(optional=True), prefix="-C", doc=InputDocumentation(doc="Output File for PSI-BLAST Checkpointing [File Out]  Optional")), ToolInput(tag="in_input_file_optional", input_type=Boolean(optional=True), prefix="-R", doc=InputDocumentation(doc="Input File for PSI-BLAST Restart [File In]  Optional")), ToolInput(tag="in_word_size_default", input_type=Boolean(optional=True), prefix="-W", doc=InputDocumentation(doc="Word size [Integer]\ndefault = 3")), ToolInput(tag="in_effective_length_database", input_type=Boolean(optional=True), prefix="-z", doc=InputDocumentation(doc="Effective length of the database (use zero for the real size) [Real]\ndefault = 0")), ToolInput(tag="in_number_keep_default", input_type=Boolean(optional=True), prefix="-K", doc=InputDocumentation(doc="Number of best hits from a region to keep [Integer]\ndefault = 0")), ToolInput(tag="in_compute_locally_optimal", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="Compute locally optimal Smith-Waterman alignments [T/F]\ndefault = F")), ToolInput(tag="in_effective_length_search", input_type=Boolean(optional=True), prefix="-Y", doc=InputDocumentation(doc="Effective length of the search space (use zero for the real size) [Real]\ndefault = 0")), ToolInput(tag="in_program_option_phiblast", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="program option for PHI-BLAST [String]\ndefault = blastpgp")), ToolInput(tag="in_hit_file_hitfile", input_type=Boolean(optional=True), prefix="-k", doc=InputDocumentation(doc="Hit File for PHI-BLAST [File In]\ndefault = hit_file")), ToolInput(tag="in_produce_html_output", input_type=Boolean(optional=True), prefix="-T", doc=InputDocumentation(doc="Produce HTML output [T/F]\ndefault = F")), ToolInput(tag="in_output_file_psiblast_matrix_optional", input_type=File(optional=True), prefix="-Q", doc=InputDocumentation(doc="Output File for PSI-BLAST Matrix in ASCII [File Out]  Optional")), ToolInput(tag="in_input_alignment_file", input_type=Boolean(optional=True), prefix="-B", doc=InputDocumentation(doc="Input Alignment File for PSI-BLAST Restart [File In]  Optional")), ToolInput(tag="in_restrict_search_list", input_type=Boolean(optional=True), prefix="-l", doc=InputDocumentation(doc="Restrict search of database to list of GI's [String]  Optional")), ToolInput(tag="in_use_case_filtering", input_type=Boolean(optional=True), prefix="-U", doc=InputDocumentation(doc="Use lower case filtering of FASTA sequence [T/F]  Optional\ndefault = F")), ToolInput(tag="in_use_based_adjustment", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="Use composition based score adjustment")), ToolInput(tag="in_asn_scoremat_input", input_type=Boolean(optional=True), prefix="-q", doc=InputDocumentation(doc="ASN.1 Scoremat input of checkpoint data:")), ToolInput(tag="in_asn_scoremat_output", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="ASN.1 Scoremat output of checkpoint data:")), ToolInput(tag="in_cost_decline_alignment", input_type=Boolean(optional=True), prefix="-L", doc=InputDocumentation(doc="Cost to decline alignment (disabled when 0) [Integer]\ndefault = 0\n"))], outputs=[ToolOutput(tag="out_output_file_stdout", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file_stdout", type_hint=File()), doc=OutputDocumentation(doc="Output File for Alignment [File Out]  Optional\ndefault = stdout")), ToolOutput(tag="out_seqalign_file_be", output_type=File(optional=True), selector=InputSelector(input_to_select="in_seqalign_file_be", type_hint=File()), doc=OutputDocumentation(doc="SeqAlign file ('Believe the query defline' must be TRUE) [File Out]  Optional")), ToolOutput(tag="out_output_file_psiblast_checkpointing_optional", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file_psiblast_checkpointing_optional", type_hint=File()), doc=OutputDocumentation(doc="Output File for PSI-BLAST Checkpointing [File Out]  Optional")), ToolOutput(tag="out_output_file_psiblast_matrix_optional", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file_psiblast_matrix_optional", type_hint=File()), doc=OutputDocumentation(doc="Output File for PSI-BLAST Matrix in ASCII [File Out]  Optional"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Blastpgp_V0_1_0().translate("wdl", allow_empty_container=True)

